EVP_OpenInit(3)

NAME
EVP_OpenInit, EVP_OpenUpdate, EVP_OpenFinal - EVP envelope decryption

LIBRARY
libcrypto, -lcrypto

SYNOPSIS

 #include <openssl/evp.h>
 int EVP_OpenInit(EVP_CIPHER_CTX *ctx,EVP_CIPHER *type,unsigned char *ek,
                int ekl,unsigned char *iv,EVP_PKEY *priv);
 void EVP_OpenUpdate(EVP_CIPHER_CTX *ctx, unsigned char *out,
         int *outl, unsigned char *in, int inl);
 void EVP_OpenFinal(EVP_CIPHER_CTX *ctx, unsigned char *out,
         int *outl);

DESCRIPTION
The EVP envelope routines are a high level interface to envelope decryption. They decrypt a public key encrypted symmetric key and then decrypt data using it.

EVP_OpenInit() initialises a cipher context ctx for decryption with cipher type. It decrypts the encrypted symmetric key of length ekl bytes passed in the ek parameter using the private key priv. The IV is supplied in the iv parameter.

EVP_OpenUpdate() and EVP_OpenFinal() have exactly the same properties as the EVP_DecryptUpdate() and EVP_DecryptFinal() routines, as documented on the the EVP_EncryptInit(3)|EVP_EncryptInit(3) manpage manual page.

RETURN VALUES
EVP_OpenInit() returns -1 on error or an non zero integer (actually the recovered secret key size) if successful.

EVP_SealUpdate() does not return a value.

EVP_SealFinal() returns 0 if the decrypt failed or 1 for success.

SEE ALSO
the evp(3)|evp(3),the section on rand(3)|rand(3) manpage the EVP_EncryptInit(3)|EVP_EncryptInit(3) manpage, the EVP_SealInit(3)|EVP_SealInit(3) manpage

HISTORY